// g++ -s -O2 -mno-cygwin -o dumper dumper.cpp && dumper

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		fprintf(stderr, "Please specify driveletter on command line.\n");
		return 1;
	}
	
	char s[256];
	sprintf(s, "\\\\.\\%c:", argv[1][0]);
	FILE *fCF = fopen(s, "rb");
	if (!fCF) { fprintf(stderr, "Could not open media.\n"); return 1; }
	unsigned char header[0x200];
	fread(header, 1, 0x200, fCF);

	char ndsFilename[32];
	memcpy(ndsFilename, header + 0xC, 4);
	strcpy(ndsFilename+4, ".nds");
	if (*(unsigned short *)(header + 0x15C) != 0xCF56) { fprintf(stderr, "Media does not contain correct data!\n"); return 1; }
	FILE *fNDS = fopen(ndsFilename, "rb");
	if (fNDS) { fprintf(stderr, "File '%s' already exists.", ndsFilename); return 1; }
	fNDS = fopen(ndsFilename, "wb");

	unsigned int size = 1 << (17 + header[0x14]);

	fseek(fCF, 0, SEEK_SET);
	for (unsigned int i=0; i<size; i+=0x200)
	{
		unsigned char buffer[0x200];
		fread(buffer, 1, 0x200, fCF);
		fwrite(buffer, 1, 0x200, fNDS);
	}

	fclose(fCF);
	fclose(fNDS);
	
	printf("Saved '%s'.\n", ndsFilename);

	return 0;
}
